#include <ctype.h>

#define SKIPEP    while((*curr == '=') || (*curr == ',') || (isspace(*curr))) curr++

static glfw_font_t *glfw_resolve_font(glfw_display_t *sd, const char *cfg)
{
	char *name, *curr;
	int size = 14, res, len;
	glfw_font_t *f;

	curr = strchr(cfg, ',');
	if (curr == NULL)
		len = strlen(cfg);
	else
		len = curr - cfg;

	name = malloc(len+1);
	memcpy(name, cfg, len);
	name[len] = '\0';

	while(curr != NULL) {
		SKIPEP;
		if (*curr == '\0') break;
		if (strncmp(curr, "size", 4) == 0) {
			curr += 4;
			SKIPEP;
			size = strtol(curr, &curr, 10);
		}
	}


	f = malloc(sizeof(glfw_font_t));
	f->size = size;
	res = FT_New_Face(sd->lib, name, 0, &f->face);
	free(name);

	if (res != 0) {
		free(f);
		return NULL;
	}

	FT_Set_Char_Size(f->face, size*64*1.3333, 0, 100, 0);

	f->asc = (f->face->ascender+32) / 64;
	f->dsc = -(f->face->descender+32) / 64;

	return f;
}

static mbtk_font_id_t mbtk_glfw_resolve_font(mbtk_display_t *display, int argc, char *argv[])
{
	int n;
	mbtk_font_id_t res;
	glfw_display_t *gd = (glfw_display_t *)display;

	for(n = 0; n < argc; n++) {
		glfw_font_t *f = glfw_resolve_font(gd, argv[n]);
		if (f != NULL) {
			res.p = f;
			return res;
		}
	}

	res.l = -1;
	return res;
}

