#include <SDL.h>
#include <SDL_thread.h>
#include <SDL_mutex.h>
#include <libmbtk/config.h>
#include <libmbtk/backend.h>

#include "font.h"

typedef struct sdl2_win_s sdl2_win_t;

typedef struct sdl2_display_s {
	mbtk_sdl2_ttfcache_t font_cache;
	double base_time;
	struct {
		/* output */
		char *data;
		size_t len;

		/* thread */
		SDL_Thread *tid;
		SDL_sem *handled;       /* main to thread: 0: thread's waiting non-blocking after a read; when main finishes picking up it increases it back to 1 to start the next read */
		SDL_sem *enable;        /* main to thread: after a succesful read, wait until enable is 1 to report it */
		unsigned disabled:1;
		SDL_Event ev;
	} iot_stdio;
	struct {
		/* output */
		int fd;
		unsigned readable:1;
		unsigned writable:1;
		unsigned closed:1;

		/* thread */
		SDL_Thread *tid;
		SDL_sem *handled;       /* main to thread: 0: thread's waiting non-blocking after a read; when main finishes picking up it increases it back to 1 to start the next read */
		int ctrlw, ctrlr;       /* control pipe fds; w is write from main, r is read on the thread's side */
		SDL_Event ev;
	} iot_fdwatch;
} sdl2_display_t;

typedef struct sdl2_win_s {
	SDL_Window *window;
	SDL_Renderer *renderer;
	SDL_Color clr;
	mbtk_sdl2_font_ctx_t *fonts;
	mbtk_sdl2_font_t *font; /* current font */
} sdl2_win_t;
