#include <libmbtk/widget.h>
#include <libmbtk/widget_imp.h>
#include <libmbtk/widget/Common.h>


int mbtk_comm_frame_fallback_minsize(mbtk_widget_t *w, long *mx, long *my)
{
	long l, r, t, b;
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = win->display->style;
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->min_box_frame_size(win, sp, w->flags, &l, &r, &t, &b);

	w->hvbox.fr_l = l; w->hvbox.fr_r = r;
	w->hvbox.fr_t = t; w->hvbox.fr_b = b;
	*mx = l+r; *my = t+b;

	return 0;
}

void mbtk_comm_frame_fallback_draw(mbtk_widget_t *w)
{
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = win->display->style;
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->draw_bg_rect(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
	style->draw_box_frame(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
}

void mbtk_comm_frame_fallback_draw_overlay(mbtk_widget_t *w)
{
	mbtk_window_t *win = w->win;
	const mbtk_style_t *style = win->display->style;
	mbtk_styleprop_t *sp = mbtk_styleprop_get(w);

	style->draw_box_overlay(win, sp, w->flags, w->hvbox.x, w->hvbox.y, w->hvbox.w, w->hvbox.h);
}


mbtk_widget_t *mbtk_comm_embed1_pre_insert(mbtk_widget_t *button, mbtk_widget_t *parent)
{
	mbtk_widget_t *child = (mbtk_widget_t *)button->hvbox.ch_first;

	/* Need to embed again, just in case set_child ran before adding the button in parent */
	if (child != NULL)
		mbtk_widget_embedded(parent, child);

	return button;
}


mbtk_widget_t *mbtk_comm_embed1_set_child(mbtk_widget_t *parent, mbtk_widget_t *w)
{
	mbtk_widget_t *res = NULL;

	if (parent->hvbox.ch_first != NULL) {
		res = (mbtk_widget_t *)parent->hvbox.ch_first;
		hvbox_unlink(parent->hvbox.ch_first);
	}
	hvbox_append_existing_box(&parent->hvbox, &w->hvbox);

	/* for the case parent button is already added */
	mbtk_widget_embedded(parent, w);
	return res;
}
